

#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>

#include "signals.h"

int main() {
	
	int *random_pointer = (int*) 0xDEAD; 
	
	sigset_t mask;

	sigaddset(&mask, SIGSEGV);
	sigaddset(&mask, SIGINT);
	
	SET_SIGNAL(SIGINT, NULL, 0);
	SET_SIGNAL(SIGQUIT, NULL, 0);
	SET_SIGNAL(SIGSEGV, &mask, 0);
	
	SIGNAL_CATCHING();
	
	CATCH_SIGNAL(SIGINT) {
		puts("Caught SIGINT");	
		goto skip_loop;
	}
	
	CATCH_SIGNAL(SIGQUIT) {
		puts("Caught SIGQUIT");	
		exit(0);
	}
	
	CATCH_SIGNAL(SIGSEGV) {
		puts("Caught SIGSEGV");	
		exit(0);
	}
	
	
	while(1) {
		puts("Test");	
		sleep(1);
	}
	
	skip_loop:
	
	puts("Loop skipped");
	
	/* Cause a segmentation fault */
	*random_pointer = 1;
	
	return 0;
}
